Index: examples/Validation.cpp
===================================================================
--- examples/Validation.cpp	(revision 87ff5a0d5ba9c8c4cc9eedbcb708eb9ac2813385)
+++ examples/Validation.cpp	(revision 92237ca859b003026b5fcdec8e41b9088fdb5736)
@@ -55,7 +55,5 @@
 //------------------------------------------------------------------------------
 
-double ptrangemin = 10;
-double ptrangemax = 10000;
-static const int Nbins = 20;
+static const int Nbins = 50;
 
 int objStyle = 1;
@@ -82,11 +80,14 @@
 double topLeftLegYmax = 0.85;
 
+unsigned int k;
+
 
 struct resolPlot
 {
-  TH1 *cenResolHist;
-  TH1 *fwdResolHist;
+  TH1* resolHist;
   double ptmin;
   double ptmax;
+  double etamin;
+  double etamax;
   double xmin;
   double xmax;
@@ -95,5 +96,7 @@
   resolPlot();
   resolPlot(double ptdown, double ptup, TString object);
+  resolPlot(double etadown, double etaup, double ptdown, double ptup, TString object);
   void set(double ptdown, double ptup, TString object, double xmin = 0, double xmax = 2);
+  void set(double etadown, double etaup, double ptdown, double ptup, TString object, double xmin = 0, double xmax = 2);
   void print(){std::cout << ptmin << std::endl;}
 };
@@ -107,4 +110,9 @@
 {
   this->set(ptdown,ptup,object);
+}
+
+resolPlot::resolPlot(double etadown, double etaup, double ptdown, double ptup, TString object)
+{
+  this->set(etadown, etaup, ptdown, ptup, object);
 }
 
@@ -115,7 +123,19 @@
   obj = object;
 
-  cenResolHist = new TH1D(obj+"_delta_pt_"+Form("%4.2f",ptmin)+"_"+Form("%4.2f",ptmax)+"_cen", obj+"_delta_pt_"+Form("%4.2f",ptmin)+"_"+Form("%4.2f",ptmax)+"_cen", 200,  xmin, xmax);
-  fwdResolHist = new TH1D(obj+"_delta_pt_"+Form("%4.2f",ptmin)+"_"+Form("%4.2f",ptmax)+"_fwd", obj+"_delta_pt_"+Form("%4.2f",ptmin)+"_"+Form("%4.2f",ptmax)+"_fwd", 200,  xmin, xmax);
+  resolHist = new TH1D(obj+"_delta_pt_"+Form("%4.2f",ptmin)+"_"+Form("%4.2f",ptmax), obj+"_delta_pt_"+Form("%4.2f",ptmin)+"_"+Form("%4.2f",ptmax), 1000,  xmin, xmax);
 }
+
+void resolPlot::set(double etadown, double etaup, double ptdown, double ptup, TString object, double xmin, double xmax)
+{
+  etamin = etadown;
+  etamax = etaup;
+  ptmin = ptdown;
+  ptmax = ptup;
+  obj = object;
+
+  resolHist = new TH1D(obj+"_delta_pt_"+Form("%4.2f",ptmin)+"_"+Form("%4.2f",ptmax)+"_"+Form("%4.2f",etamin)+"_"+Form("%4.2f",etamax), obj+"_delta_pt_"+Form("%4.2f",ptmin)+"_"+Form("%4.2f",ptmax)+"_"+Form("%4.2f",etamin)+"_"+Form("%4.2f",etamax), 1000,  xmin, xmax);
+}
+
+
 
 void HistogramsCollection(std::vector<resolPlot> *histos, double ptmin, double ptmax, TString obj, double xmin = 0, double xmax = 2)
@@ -136,4 +156,24 @@
 }
 
+
+void HistogramsCollectionVsEta(std::vector<resolPlot> *histos, double etamin, double etamax, double ptmin, double ptmax, TString obj, double xmin = 0, double xmax = 2)
+{
+  resolPlot ptemp;
+  double width;
+  double etadown;
+  double etaup;
+
+  for (int i = 0; i < Nbins; i++)
+  {
+    width = (etamax - etamin) / Nbins;
+    etadown = etamin + i * width;
+    etaup = etamin + (i+1) * width;
+
+    ptemp.set(etadown, etaup, ptmin, ptmax, obj, xmin, xmax);
+    histos->push_back(ptemp);
+  }
+}
+
+
 //------------------------------------------------------------------------------
 
@@ -165,5 +205,5 @@
 
 template<typename T>
-std::pair<TH1D*, TH1D*> GetEff(TClonesArray *branchReco, TClonesArray *branchParticle, TString name, int pdgID, ExRootTreeReader *treeReader)
+TH1D* GetEffPt(TClonesArray *branchReco, TClonesArray *branchParticle, TString name, int pdgID, double ptmin, double ptmax, double etamin, double etamax, ExRootTreeReader *treeReader)
 {
 
@@ -183,18 +223,12 @@
   Int_t i, j;
 
-  TH1D *histGenPtcen = new TH1D(name+" gen spectra Pt",name+" gen spectra cen", Nbins, TMath::Log10(ptrangemin), TMath::Log10(ptrangemax));
-  TH1D *histRecoPtcen = new TH1D(name+" reco spectra Pt",name+" reco spectra cen", Nbins, TMath::Log10(ptrangemin), TMath::Log10(ptrangemax));
-  TH1D *histGenPtfwd  = new TH1D(name+" gen spectra Eta",name+" gen spectra fwd", Nbins, TMath::Log10(ptrangemin), TMath::Log10(ptrangemax));
-  TH1D *histRecoPtfwd = new TH1D(name+" reco spectra Eta",name+" reco spectra fwd", Nbins, TMath::Log10(ptrangemin), TMath::Log10(ptrangemax));
-
-  histGenPtcen->SetDirectory(0);
-  histRecoPtcen->SetDirectory(0);
-  histGenPtfwd->SetDirectory(0);
-  histRecoPtfwd->SetDirectory(0);
-
-  BinLogX(histGenPtcen);
-  BinLogX(histRecoPtcen);
-  BinLogX(histGenPtfwd);
-  BinLogX(histRecoPtfwd);
+  TH1D *histGenPt = new TH1D(name+" gen spectra Pt",name+" gen spectra cen", Nbins, TMath::Log10(ptmin), TMath::Log10(ptmax));
+  TH1D *histRecoPt = new TH1D(name+" reco spectra Pt",name+" reco spectra cen", Nbins, TMath::Log10(ptmin), TMath::Log10(ptmax));
+
+  histGenPt->SetDirectory(0);
+  histRecoPt->SetDirectory(0);
+
+  BinLogX(histGenPt);
+  BinLogX(histRecoPt);
 
   // Loop over all events
@@ -213,7 +247,11 @@
       deltaR = 999;
 
-      if (particle->PID == pdgID && genMomentum.Pt() > ptrangemin && genMomentum.Pt() < ptrangemax )
+      pt  = genMomentum.Pt();
+      eta = TMath::Abs(genMomentum.Eta());
+
+      if(eta > etamax || eta < etamin ) continue;
+
+      if (particle->PID == pdgID && genMomentum.Pt() > ptmin && genMomentum.Pt() < ptmax )
       {
-
         // Loop over all reco object in event
         for(j = 0; j < branchReco->GetEntriesFast(); ++j)
@@ -229,6 +267,127 @@
           {
             Jet *jet = (Jet *)recoObj;
-            if(jet->BTag != 1) continue;
+            if( !(jet->BTag & (1 << 0)) ) continue;
+
+            //if(jet->BTag != ) continue;
           }
+
+            if(TMath::Abs(pdgID) == 4)
+          {
+            Jet *jet = (Jet *)recoObj;
+            if( !(jet->BTag & (1 << 0)) ) continue;
+          }
+
+           if(TMath::Abs(pdgID) == 1)
+          {
+            Jet *jet = (Jet *)recoObj;
+            if( !(jet->BTag & (1 << 0)) ) continue;
+          }
+
+          if(TMath::Abs(pdgID) == 15)
+          {
+            Jet *jet = (Jet *)recoObj;
+            if(jet->TauTag != 1) continue;
+          }
+
+
+          if(genMomentum.DeltaR(recoMomentum) < deltaR)
+          {
+            deltaR = genMomentum.DeltaR(recoMomentum);
+            bestRecoMomentum = recoMomentum;
+          }
+        }
+
+        histGenPt->Fill(pt);
+        if(deltaR < 0.3) { histRecoPt->Fill(pt); }
+
+      }
+    }
+  }
+
+  histRecoPt->Sumw2();
+  histGenPt->Sumw2();
+
+  histRecoPt->Divide(histGenPt);
+  histRecoPt->Scale(100.);
+
+  return histRecoPt;
+}
+
+template<typename T>
+TH1D* GetEffEta(TClonesArray *branchReco, TClonesArray *branchParticle, TString name, int pdgID, double ptmin, double ptmax, double etamin, double etamax, ExRootTreeReader *treeReader)
+{
+
+  cout << "** Computing Efficiency of reconstructing "<< branchReco->GetName() << " induced by " << branchParticle->GetName() << " with PID " << pdgID << endl;
+
+  Long64_t allEntries = treeReader->GetEntries();
+
+  GenParticle *particle;
+  T *recoObj;
+
+  TLorentzVector recoMomentum, genMomentum, bestRecoMomentum;
+
+  Float_t deltaR;
+  Float_t pt, eta;
+  Long64_t entry;
+
+  Int_t i, j;
+
+  TH1D *histGenEta = new TH1D(name+" gen spectra Eta",name+" gen spectra", Nbins, etamin, etamax);
+  TH1D *histRecoEta = new TH1D(name+" reco spectra Eta",name+" reco spectra", Nbins, etamin, etamax);
+
+  histGenEta->SetDirectory(0);
+  histRecoEta->SetDirectory(0);
+
+  // Loop over all events
+  for(entry = 0; entry < allEntries; ++entry)
+  {
+    // Load selected branches with data from specified event
+    treeReader->ReadEntry(entry);
+
+    // Loop over all generated particle in event
+    for(i = 0; i < branchParticle->GetEntriesFast(); ++i)
+    {
+
+      particle = (GenParticle*) branchParticle->At(i);
+      genMomentum = particle->P4();
+
+      deltaR = 999;
+
+      pt  = genMomentum.Pt();
+      eta = genMomentum.Eta();
+
+      if(pt > ptmax || pt < ptmin ) continue;
+
+      if (particle->PID == pdgID && genMomentum.Pt() > ptmin && genMomentum.Pt() < ptmax )
+      {
+        // Loop over all reco object in event
+        for(j = 0; j < branchReco->GetEntriesFast(); ++j)
+        {
+          recoObj = (T*)branchReco->At(j);
+          recoMomentum = recoObj->P4();
+          // this is simply to avoid warnings from initial state particle
+          // having infite rapidity ...
+        //if(Momentum.Px() == 0 && genMomentum.Py() == 0) continue;
+
+          // take the closest parton candidate
+          if(TMath::Abs(pdgID) == 5)
+          {
+            Jet *jet = (Jet *)recoObj;
+            if( !(jet->BTag & (1 << 0)) ) continue;
+
+          }
+
+          if(TMath::Abs(pdgID) == 4)
+          {
+            Jet *jet = (Jet *)recoObj;
+            if( !(jet->BTag & (1 << 0)) ) continue;
+          }
+
+           if(TMath::Abs(pdgID) == 1)
+          {
+            Jet *jet = (Jet *)recoObj;
+            if( !(jet->BTag & (1 << 0)) ) continue;
+          }
+
           if(TMath::Abs(pdgID) == 15)
           {
@@ -243,40 +402,217 @@
         }
 
-        pt  = genMomentum.Pt();
-        eta = genMomentum.Eta();
-
-        if (TMath::Abs(eta) < 1.5)
+        histGenEta->Fill(eta);
+        if(deltaR < 0.3) { histRecoEta->Fill(eta); }
+
+      }
+    }
+  }
+
+  histRecoEta->Sumw2();
+  histGenEta->Sumw2();
+
+  histRecoEta->Divide(histGenEta);
+  histRecoEta->Scale(100.);
+
+  return histRecoEta;
+}
+
+
+
+template<typename T>
+TH1D* GetTauEffPt(TClonesArray *branchReco, TClonesArray *branchParticle, TString name, int pdgID, double ptmin, double ptmax, double etamin, double etamax, ExRootTreeReader *treeReader)
+{
+
+  cout << "** Computing Efficiency of reconstructing "<< branchReco->GetName() << " induced by " << branchParticle->GetName() << " with PID " << pdgID << endl;
+
+  Long64_t allEntries = treeReader->GetEntries();
+
+  GenParticle *particle;
+  T *recoObj;
+
+  TLorentzVector recoMomentum, genMomentum, bestRecoMomentum;
+
+  Float_t deltaR;
+  Float_t pt, eta;
+  Long64_t entry;
+
+  Int_t i, j;
+
+  TH1D *histGenPt = new TH1D(name+" gen spectra Pt",name+" gen spectra cen", Nbins, TMath::Log10(ptmin), TMath::Log10(ptmax));
+  TH1D *histRecoPt = new TH1D(name+" reco spectra Pt",name+" reco spectra cen", Nbins, TMath::Log10(ptmin), TMath::Log10(ptmax));
+
+  histGenPt->SetDirectory(0);
+  histRecoPt->SetDirectory(0);
+
+  BinLogX(histGenPt);
+  BinLogX(histRecoPt);
+
+  // Loop over all events
+  for(entry = 0; entry < allEntries; ++entry)
+  {
+    // Load selected branches with data from specified event
+    treeReader->ReadEntry(entry);
+
+    // Loop over all generated particle in event
+    for(i = 0; i < branchParticle->GetEntriesFast(); ++i)
+    {
+
+      particle = (GenParticle*) branchParticle->At(i);
+      genMomentum = particle->P4();
+
+      deltaR = 999;
+
+      pt  = genMomentum.Pt();
+      eta = TMath::Abs(genMomentum.Eta());
+
+      if(eta > etamax || eta < etamin ) continue;
+
+      if (particle->PID == pdgID && genMomentum.Pt() > ptmin && genMomentum.Pt() < ptmax )
+      {
+        // Loop over all reco object in event
+        for(j = 0; j < branchReco->GetEntriesFast(); ++j)
         {
-          histGenPtcen->Fill(pt);
-          if(deltaR < 0.3) { histRecoPtcen->Fill(pt); }
+          recoObj = (T*)branchReco->At(j);
+          recoMomentum = recoObj->P4();
+          // this is simply to avoid warnings from initial state particle
+          // having infite rapidity ...
+          //if(Momentum.Px() == 0 && genMomentum.Py() == 0) continue;
+
+          if(TMath::Abs(pdgID) == 1)
+          {
+            Jet *jet = (Jet *)recoObj;
+            if( jet->TauTag != 1 ) continue;
+          }
+
+          if(TMath::Abs(pdgID) == 15)
+          {
+            Jet *jet = (Jet *)recoObj;
+            if(jet->TauTag != 1) continue;
+          }
+
+          if(genMomentum.DeltaR(recoMomentum) < deltaR)
+          {
+            deltaR = genMomentum.DeltaR(recoMomentum);
+            bestRecoMomentum = recoMomentum;
+          }
         }
-        else if (TMath::Abs(eta) < 2.5)
+
+        histGenPt->Fill(pt);
+        if(deltaR < 0.3) { histRecoPt->Fill(pt); }
+
+      }
+    }
+  }
+
+  histRecoPt->Sumw2();
+  histGenPt->Sumw2();
+
+
+  histRecoPt->Divide(histGenPt);
+  histRecoPt->Scale(100.);
+  if(TMath::Abs(pdgID) == 15) histRecoPt->Scale(1/0.648);
+
+  return histRecoPt;
+}
+
+template<typename T>
+TH1D* GetTauEffEta(TClonesArray *branchReco, TClonesArray *branchParticle, TString name, int pdgID, double ptmin, double ptmax, double etamin, double etamax, ExRootTreeReader *treeReader)
+{
+
+  cout << "** Computing Efficiency of reconstructing "<< branchReco->GetName() << " induced by " << branchParticle->GetName() << " with PID " << pdgID << endl;
+
+  Long64_t allEntries = treeReader->GetEntries();
+
+  GenParticle *particle;
+  T *recoObj;
+
+  TLorentzVector recoMomentum, genMomentum, bestRecoMomentum;
+
+  Float_t deltaR;
+  Float_t pt, eta;
+  Long64_t entry;
+
+  Int_t i, j;
+
+  TH1D *histGenEta = new TH1D(name+" gen spectra Eta",name+" gen spectra", Nbins, etamin, etamax);
+  TH1D *histRecoEta = new TH1D(name+" reco spectra Eta",name+" reco spectra", Nbins, etamin, etamax);
+
+  histGenEta->SetDirectory(0);
+  histRecoEta->SetDirectory(0);
+
+  // Loop over all events
+  for(entry = 0; entry < allEntries; ++entry)
+  {
+    // Load selected branches with data from specified event
+    treeReader->ReadEntry(entry);
+
+    // Loop over all generated particle in event
+    for(i = 0; i < branchParticle->GetEntriesFast(); ++i)
+    {
+
+      particle = (GenParticle*) branchParticle->At(i);
+      genMomentum = particle->P4();
+
+      deltaR = 999;
+
+      pt  = genMomentum.Pt();
+      eta = genMomentum.Eta();
+
+      if(pt > ptmax || pt < ptmin ) continue;
+
+      if (particle->PID == pdgID && genMomentum.Pt() > ptmin && genMomentum.Pt() < ptmax )
+      {
+        // Loop over all reco object in event
+        for(j = 0; j < branchReco->GetEntriesFast(); ++j)
         {
-          histGenPtfwd->Fill(pt);
-          if(deltaR < 0.3) { histRecoPtfwd->Fill(pt); }
-
+          recoObj = (T*)branchReco->At(j);
+          recoMomentum = recoObj->P4();
+          // this is simply to avoid warnings from initial state particle
+          // having infite rapidity ...
+        //if(Momentum.Px() == 0 && genMomentum.Py() == 0) continue;
+
+         if(TMath::Abs(pdgID) == 1)
+          {
+            Jet *jet = (Jet *)recoObj;
+            if( jet->TauTag != 1 ) continue;
+          }
+
+          if(TMath::Abs(pdgID) == 15)
+          {
+            Jet *jet = (Jet *)recoObj;
+            if(jet->TauTag != 1) continue;
+          }
+
+          if(genMomentum.DeltaR(recoMomentum) < deltaR)
+          {
+            deltaR = genMomentum.DeltaR(recoMomentum);
+            bestRecoMomentum = recoMomentum;
+          }
         }
+
+        histGenEta->Fill(eta);
+        if(deltaR < 0.3) { histRecoEta->Fill(eta); }
+
       }
     }
   }
 
-
-  std::pair<TH1D*,TH1D*> histos;
-
-  histRecoPtcen->Divide(histGenPtcen);
-  histRecoPtfwd->Divide(histGenPtfwd);
-
-  histos.first = histRecoPtcen;
-  histos.second = histRecoPtfwd;
-
-  return histos;
+  histRecoEta->Sumw2();
+  histGenEta->Sumw2();
+
+  histRecoEta->Divide(histGenEta);
+  histRecoEta->Scale(100.);
+  if(TMath::Abs(pdgID) == 15) histRecoEta->Scale(1/0.648);
+
+  return histRecoEta;
 }
 
+
 template<typename T>
-void GetEres(std::vector<resolPlot> *histos, TClonesArray *branchReco, TClonesArray *branchParticle, int pdgID, ExRootTreeReader *treeReader)
+void GetPtres(std::vector<resolPlot> *histos, TClonesArray *branchReco, TClonesArray *branchParticle, int pdgID, Double_t etaMin, Double_t etaMax, ExRootTreeReader *treeReader)
 {
   Long64_t allEntries = treeReader->GetEntries();
 
-  cout << "** Computing resolution of " << branchReco->GetName() << " induced by " << branchParticle->GetName() << " with PID " << pdgID << endl;
+  cout << "** Computing pt resolution of " << branchReco->GetName() << " induced by " << branchParticle->GetName() << " with PID " << pdgID << endl;
 
   GenParticle *particle;
@@ -328,13 +664,12 @@
       if(deltaR < 0.3)
       {
-        pt  = bestGenMomentum.E();
+        pt  = bestGenMomentum.Pt();
         eta = TMath::Abs(bestGenMomentum.Eta());
 
         for (bin = 0; bin < Nbins; bin++)
         {
-          if(pt > histos->at(bin).ptmin && pt < histos->at(bin).ptmax && eta < 2.5)
+          if(pt > histos->at(bin).ptmin && pt < histos->at(bin).ptmax && eta > etaMin && eta < etaMax)
           {
-            if (eta < 1.5) {histos->at(bin).cenResolHist->Fill(recoMomentum.E()/bestGenMomentum.E());}
-            else if (eta < 2.5) {histos->at(bin).fwdResolHist->Fill(recoMomentum.E()/bestGenMomentum.E());}
+            histos->at(bin).resolHist->Fill(recoMomentum.Pt()/bestGenMomentum.Pt());
           }
         }
@@ -346,9 +681,9 @@
 
 template<typename T>
-void GetPtres(std::vector<resolPlot> *histos, TClonesArray *branchReco, TClonesArray *branchParticle, int pdgID, ExRootTreeReader *treeReader)
+void GetEres(std::vector<resolPlot> *histos, TClonesArray *branchReco, TClonesArray *branchParticle, int pdgID, Double_t etaMin, Double_t etaMax, ExRootTreeReader *treeReader)
 {
   Long64_t allEntries = treeReader->GetEntries();
 
-  cout << "** Computing pt resolution of " << branchReco->GetName() << " induced by " << branchParticle->GetName() << " with PID " << pdgID << endl;
+  cout << "** Computing e resolution of " << branchReco->GetName() << " induced by " << branchParticle->GetName() << " with PID " << pdgID << endl;
 
   GenParticle *particle;
@@ -358,5 +693,5 @@
 
   Float_t deltaR;
-  Float_t pt, eta;
+  Float_t e, eta;
   Long64_t entry;
 
@@ -369,5 +704,5 @@
     treeReader->ReadEntry(entry);
 
-    // Loop over all reconstructed jets in event
+     // Loop over all reconstructed jets in event
     for(i = 0; i < branchReco->GetEntriesFast(); ++i)
     {
@@ -400,13 +735,12 @@
       if(deltaR < 0.3)
       {
-        pt  = bestGenMomentum.Pt();
+        e  = bestGenMomentum.E();
         eta = TMath::Abs(bestGenMomentum.Eta());
 
         for (bin = 0; bin < Nbins; bin++)
         {
-          if(pt > histos->at(bin).ptmin && pt < histos->at(bin).ptmax && eta < 2.5)
+          if(e > histos->at(bin).ptmin && e < histos->at(bin).ptmax && eta > etaMin && eta < etaMax)
           {
-            if (eta < 1.5) {histos->at(bin).cenResolHist->Fill(recoMomentum.Pt()/bestGenMomentum.Pt());}
-            else if (eta < 2.5) {histos->at(bin).fwdResolHist->Fill(recoMomentum.Pt()/bestGenMomentum.Pt());}
+            histos->at(bin).resolHist->Fill(recoMomentum.E()/bestGenMomentum.E());
           }
         }
@@ -417,5 +751,149 @@
 
 
-void GetJetsEres(std::vector<resolPlot> *histos, TClonesArray *branchJet, TClonesArray *branchGenJet, ExRootTreeReader *treeReader)
+template<typename T>
+void GetPtresVsEta(std::vector<resolPlot> *histos, TClonesArray *branchReco, TClonesArray *branchParticle, int pdgID, Double_t ptMin, Double_t ptMax, ExRootTreeReader *treeReader)
+{
+  Long64_t allEntries = treeReader->GetEntries();
+
+  cout << "** Computing pt resolution of " << branchReco->GetName() << " induced by " << branchParticle->GetName() << " with PID " << pdgID << endl;
+
+  GenParticle *particle;
+  T* recoObj;
+
+  TLorentzVector recoMomentum, genMomentum, bestGenMomentum;
+
+  Float_t deltaR;
+  Float_t pt, eta;
+  Long64_t entry;
+
+  Int_t i, j, bin;
+
+  // Loop over all events
+  for(entry = 0; entry < allEntries; ++entry)
+  {
+    // Load selected branches with data from specified event
+    treeReader->ReadEntry(entry);
+
+    // Loop over all reconstructed jets in event
+    for(i = 0; i < branchReco->GetEntriesFast(); ++i)
+    {
+      recoObj = (T*) branchReco->At(i);
+      recoMomentum = recoObj->P4();
+
+      deltaR = 999;
+
+     // Loop over all hard partons in event
+     for(j = 0; j < branchParticle->GetEntriesFast(); ++j)
+     {
+        particle = (GenParticle*) branchParticle->At(j);
+        if (particle->PID == pdgID && particle->Status == 1)
+        {
+          genMomentum = particle->P4();
+
+          // this is simply to avoid warnings from initial state particle
+          // having infite rapidity ...
+          if(genMomentum.Px() == 0 && genMomentum.Py() == 0) continue;
+
+          // take the closest parton candidate
+          if(genMomentum.DeltaR(recoMomentum) < deltaR)
+          {
+             deltaR = genMomentum.DeltaR(recoMomentum);
+             bestGenMomentum = genMomentum;
+          }
+        }
+      }
+
+      if(deltaR < 0.3)
+      {
+        pt  = bestGenMomentum.Pt();
+        eta = bestGenMomentum.Eta();
+
+        for (bin = 0; bin < Nbins; bin++)
+        {
+          if(eta > histos->at(bin).etamin && eta < histos->at(bin).etamax && pt > ptMin && pt < ptMax)
+          {
+             histos->at(bin).resolHist->Fill(recoMomentum.Pt()/bestGenMomentum.Pt());
+          }
+        }
+      }
+    }
+  }
+}
+
+template<typename T>
+void GetEresVsEta(std::vector<resolPlot> *histos, TClonesArray *branchReco, TClonesArray *branchParticle, int pdgID, Double_t eMin, Double_t eMax, ExRootTreeReader *treeReader)
+{
+  Long64_t allEntries = treeReader->GetEntries();
+
+  cout << "** Computing E resolution of " << branchReco->GetName() << " induced by " << branchParticle->GetName() << " with PID " << pdgID << endl;
+
+  GenParticle *particle;
+  T* recoObj;
+
+  TLorentzVector recoMomentum, genMomentum, bestGenMomentum;
+
+  Float_t deltaR;
+  Float_t e, eta;
+  Long64_t entry;
+
+  Int_t i, j, bin;
+
+  // Loop over all events
+  for(entry = 0; entry < allEntries; ++entry)
+  {
+    // Load selected branches with data from specified event
+    treeReader->ReadEntry(entry);
+
+    // Loop over all reconstructed jets in event
+    for(i = 0; i < branchReco->GetEntriesFast(); ++i)
+    {
+      recoObj = (T*) branchReco->At(i);
+      recoMomentum = recoObj->P4();
+
+      deltaR = 999;
+
+     // Loop over all hard partons in event
+     for(j = 0; j < branchParticle->GetEntriesFast(); ++j)
+     {
+        particle = (GenParticle*) branchParticle->At(j);
+        if (particle->PID == pdgID && particle->Status == 1)
+        {
+          genMomentum = particle->P4();
+
+          // this is simply to avoid warnings from initial state particle
+          // having infite rapidity ...
+          if(genMomentum.Px() == 0 && genMomentum.Py() == 0) continue;
+
+          // take the closest parton candidate
+          if(genMomentum.DeltaR(recoMomentum) < deltaR)
+          {
+             deltaR = genMomentum.DeltaR(recoMomentum);
+             bestGenMomentum = genMomentum;
+          }
+        }
+      }
+
+      if(deltaR < 0.3)
+      {
+        e  = bestGenMomentum.E();
+        eta = bestGenMomentum.Eta();
+
+
+
+        for (bin = 0; bin < Nbins; bin++)
+        {
+          if(eta > histos->at(bin).etamin && eta < histos->at(bin).etamax && e > eMin && e < eMax)
+          {
+             histos->at(bin).resolHist->Fill(recoMomentum.E()/bestGenMomentum.E());
+          }
+        }
+      }
+    }
+  }
+}
+
+
+
+void GetJetsEres(std::vector<resolPlot> *histos, TClonesArray *branchJet, TClonesArray *branchGenJet, ExRootTreeReader *treeReader, Double_t etaMin, Double_t etaMax)
 {
 
@@ -470,23 +948,211 @@
       }
 
-      if(deltaR < 0.25)
+      if(deltaR < 0.3)
       {
         pt  = genJetMomentum.E();
-        eta = TMath::Abs(genJetMomentum.Eta());
+        eta = genJetMomentum.Eta();
 
         for (bin = 0; bin < Nbins; bin++)
         {
-            if(pt > histos->at(bin).ptmin && pt < histos->at(bin).ptmax && eta < 1.5)
-            {
-                histos->at(bin).cenResolHist->Fill(jetMomentum.E()/bestGenJetMomentum.E());
-            }
-            else if(pt > histos->at(bin).ptmin && pt < histos->at(bin).ptmax && eta < 2.5)
-            {
-                histos->at(bin).fwdResolHist->Fill(jetMomentum.E()/bestGenJetMomentum.E());
-            }
+          if(pt > histos->at(bin).ptmin && pt < histos->at(bin).ptmax && eta < etaMax && eta > etaMin)
+          {
+             histos->at(bin).resolHist->Fill(jetMomentum.E()/bestGenJetMomentum.E());
+          }
         }
       }
     }
   }
+}
+
+void GetJetsEresVsEta(std::vector<resolPlot> *histos, TClonesArray *branchJet, TClonesArray *branchGenJet, ExRootTreeReader *treeReader, Double_t eMin, Double_t eMax)
+{
+
+  Long64_t allEntries = treeReader->GetEntries();
+
+  cout << "** Computing resolution of " << branchJet->GetName() << " induced by " << branchGenJet->GetName() << endl;
+
+  Jet *jet, *genjet;
+
+  TLorentzVector jetMomentum, genJetMomentum, bestGenJetMomentum;
+
+  Float_t deltaR;
+  Float_t pt, eta;
+  Long64_t entry;
+
+  Int_t i, j, bin;
+
+  // Loop over all events
+  for(entry = 0; entry < allEntries; ++entry)
+  {
+    // Load selected branches with data from specified event
+    treeReader->ReadEntry(entry);
+
+    if(entry%10000 == 0) cout << "Event number: "<< entry <<endl;
+
+    // Loop over all reconstructed jets in event
+    for(i = 0; i < TMath::Min(2,branchJet->GetEntriesFast()); ++i) //branchJet->GetEntriesFast(); ++i)
+    {
+
+      jet = (Jet*) branchJet->At(i);
+      jetMomentum = jet->P4();
+
+      deltaR = 999;
+
+     // Loop over all hard partons in event
+     for(j = 0; j < TMath::Min(2,branchGenJet->GetEntriesFast()); ++j)
+     {
+        genjet = (Jet*) branchGenJet->At(j);
+
+        genJetMomentum = genjet->P4();
+
+        // this is simply to avoid warnings from initial state particle
+        // having infite rapidity ...
+        if(genJetMomentum.Px() == 0 && genJetMomentum.Py() == 0) continue;
+
+        // take the closest parton candidate
+        if(genJetMomentum.DeltaR(jetMomentum) < deltaR)
+        {
+           deltaR = genJetMomentum.DeltaR(jetMomentum);
+           bestGenJetMomentum = genJetMomentum;
+        }
+      }
+
+      if(deltaR < 0.3)
+      {
+
+        pt  = genJetMomentum.E();
+        eta = genJetMomentum.Eta();
+
+        for (bin = 0; bin < Nbins; bin++)
+        {
+          if(eta > histos->at(bin).etamin && eta < histos->at(bin).etamax && pt < eMax && pt > eMin)
+          {
+             histos->at(bin).resolHist->Fill(jetMomentum.E()/bestGenJetMomentum.E());
+          }
+        }
+      }
+    }
+  }
+}
+
+
+
+std::pair<Double_t, Double_t> GausFit(TH1* hist)
+{
+  TF1 *f1 = new TF1("f1", "gaus", hist->GetMean()-2*hist->GetRMS(), hist->GetMean()+2*hist->GetRMS());
+  hist->Fit("f1","RQ");
+
+  TF1 *f2 = new TF1("f2", "gaus", f1->GetParameter(1) - 2*f1->GetParameter(2), f1->GetParameter(1) + 2*f1->GetParameter(2));
+  hist->Fit("f2","RQ");
+
+  Double_t sig = f2->GetParameter(2);
+  Double_t sigErr = f2->GetParError(2);
+
+  delete f1;
+  delete f2;
+  return make_pair (sig, sigErr);
+}
+
+
+TGraphErrors EresGraph(std::vector<resolPlot> *histos, bool rms = false)
+{
+  Int_t bin;
+  Int_t count = 0;
+  TGraphErrors gr = TGraphErrors(Nbins/2);
+  double val, error;
+  for (bin = 0; bin < Nbins; bin++)
+  {
+     std::pair<Double_t, Double_t> sigvalues = GausFit(histos->at(bin).resolHist);
+     if (rms == true)
+     {
+       gr.SetPoint(count,(histos->at(bin).ptmin+histos->at(bin).ptmax)/2.0, 100*histos->at(bin).resolHist->GetRMS());
+       //gr.SetPointError(count,0, 100*sigvalues.second); // to correct
+       error = 100*histos->at(bin).resolHist->GetRMSError();
+       val = 100*histos->at(bin).resolHist->GetRMS();
+       if(error > 0.2*val) error = 0.2*val;
+       gr.SetPointError(count,0, error); // to correct
+     }
+     else
+     {
+
+       gr.SetPoint(count,(histos->at(bin).ptmin+histos->at(bin).ptmax)/2.0, 100*sigvalues.first);
+       error = 100*sigvalues.second;
+       val = 100*sigvalues.first;
+       if(error > 0.2*val) error = 0.2*val;
+       gr.SetPointError(count,0, error); // to correct
+       //gr.SetPointError(count,0, 100*sigvalues.second);
+     }
+     count++;
+  }
+
+  return gr;
+}
+
+TGraphErrors MetResGraph(std::vector<resolPlot> *histos, bool rms = false)
+{
+  Int_t bin;
+  Int_t count = 0;
+  TGraphErrors gr = TGraphErrors(Nbins/2);
+  double val, error;
+  for (bin = 0; bin < Nbins; bin++)
+  {
+     std::pair<Double_t, Double_t> sigvalues = GausFit(histos->at(bin).resolHist);
+     if (rms == true)
+     {
+       gr.SetPoint(count,(histos->at(bin).ptmin+histos->at(bin).ptmax)/2.0, histos->at(bin).resolHist->GetRMS());
+       error = histos->at(bin).resolHist->GetRMSError();
+       val = histos->at(bin).resolHist->GetRMS();
+       if(error > 0.2*val) error = 0.2*val;
+       gr.SetPointError(count,0, error); // to correct
+     }
+     else
+     {
+
+       gr.SetPoint(count,(histos->at(bin).ptmin+histos->at(bin).ptmax)/2.0, sigvalues.first);
+       val = sigvalues.first;
+       error = sigvalues.second;
+       if(error > 0.2*val) error = 0.2*val;
+       gr.SetPointError(count,0, error);
+       //gr.SetPointError(count,0, 100*sigvalues.second);
+     }
+     count++;
+  }
+
+  return gr;
+}
+
+
+
+TGraphErrors EresGraphVsEta(std::vector<resolPlot> *histos, bool rms = false)
+{
+  Int_t bin;
+  Int_t count = 0;
+  TGraphErrors gr = TGraphErrors(Nbins/2);
+  double val, error;
+  for (bin = 0; bin < Nbins; bin++)
+  {
+
+     std::pair<Double_t, Double_t> sigvalues = GausFit(histos->at(bin).resolHist);
+     if (rms == true)
+     {
+       gr.SetPoint(count,(histos->at(bin).etamin+histos->at(bin).etamax)/2.0, histos->at(bin).resolHist->GetRMS());
+       error = 100*histos->at(bin).resolHist->GetRMSError();
+       val = 100*histos->at(bin).resolHist->GetRMS();
+       if(error > 0.2*val) error = 0.2*val;
+       gr.SetPointError(count,0, error); // to correct
+     }
+     else
+     {
+       gr.SetPoint(count,(histos->at(bin).etamin+histos->at(bin).etamax)/2.0, 100*sigvalues.first);
+       val = 100*sigvalues.first;
+       error = 100*sigvalues.second;
+       if(error > 0.2*val) error = 0.2*val;
+       gr.SetPointError(count,0, error);
+       //gr.SetPointError(count,0, 100*sigvalues.second);
+     }
+     count++;
+  }
+
+  return gr;
 }
 
@@ -536,6 +1202,5 @@
         if(ht > histos->at(bin).ptmin && ht < histos->at(bin).ptmax )
         {
-          histos->at(bin).cenResolHist->Fill(met->P4().Px());
-          histos->at(bin).fwdResolHist->Fill(met->P4().Py());
+          histos->at(bin).resolHist->Fill(met->P4().Px());
         }
       }
